# Supporting code for an "Introduction to Bayesian Optimization"

This directory contains all the Matlab/Octave programs that are
needed to reproduce the demos in the lecture

Introduction to Bayesian Optimization
—
and more generally to the Design
& Analysis of Computer Experiments (DACE)
—

given by Julien Bect during the 2021 Peyresq Summer School
(June 20–26, 2021, online)


## Directory layout

### `stk` directory

This directory contains a recent snapshot of the STK toolbox for
Matlab/Octave (commit fecfdc1da1ed7a0859067aa7818a69bceea69154,
from June 14, 2021), which should correspond more or less to the
soon-to-be-released version 2.7.0.

Most of the demos shown during the lecture are actually already part
of STK (cf. `stk/examples` directory).

### `additional_scripts` directory

This directory contains some additional scripts, in particular the
demo of Bayesian optimization in 2D on the Branin-Hoo function.


## Getting started

Start your favorite Matlab/Octave variant (any recent release of
either software should do).

Run the script `stk_init.m` to prepare STK.

Then run any of the demonstration script.  Enjoy!
