% COMPUTE_EHVI [internal]

% Copyright Notice
%
%    Copyright (C) 2017 CentraleSupelec
%
%    Authors:  Etienne Leloup           <etienne.leloup@free.fr>
%              Guillaume Maistre-Bazin  <g.maistre.bazin@gmail.com>
%              Lucain Pouget            <lucainp@gmail.com>
%              Julien Bect              <julien.bect@centralesupelec.fr>

% Copying Permission Statement
%
%    This file is part of STK-contrib-moo-1
%      (https://sourceforge.net/p/kriging/contrib-moo-1/).
%
%    STK-contrib-moo-1 is free software;  you can redistribute it  and/or
%    modify it  under the terms of the  GNU Lesser General Public License
%    as published by the Free Software Foundation;  either version 2.1 of
%    the License, or (at your option) any later version.
%
%    STK-contrib-moo-1 is distributed in the hope that it will be useful,
%    but  WITHOUT  ANY  WARRANTY;  without even  the implied  warranty of
%    MERCHANTABILITY or FITNESS  FOR A  PARTICULAR PURPOSE.  See the  GNU
%    Lesser General Public License for more details.
%
%    You should  have received  a copy  of the  GNU Lesser General Public
%    License along with STK-contrib-moo-1;  if not, see
%                                          <http://www.gnu.org/licenses/>.

function ehvi = compute_ehvi (data, x, model, z_ref)

x_obs = data(:, 1:end-2);
z_obs = data(:, end-1:end);

z_pred_1 = stk_predict (model(1), x_obs, z_obs(:, 1), x);
z_pred_2 = stk_predict (model(2), x_obs, z_obs(:, 2), x);

ehvi = stk_sampcrit_cehvi_eval ([z_pred_1.mean z_pred_2.mean], ...
    sqrt ([z_pred_1.var z_pred_2.var]), z_obs, z_ref);

ehvi = max (ehvi, 0);

end % function
