% SIMULATE_NAN_DATA [internal]

% Copyright Notice
%
%    Copyright (C) 2017 CentraleSupelec
%
%    Authors:  Etienne Leloup           <etienne.leloup@free.fr>
%              Guillaume Maistre-Bazin  <g.maistre.bazin@gmail.com>
%              Lucain Pouget            <lucainp@gmail.com>

% Copying Permission Statement
%
%    This file is part of STK-contrib-moo-1
%      (https://sourceforge.net/p/kriging/contrib-moo-1/).
%
%    STK-contrib-moo-1 is free software;  you can redistribute it  and/or
%    modify it  under the terms of the  GNU Lesser General Public License
%    as published by the Free Software Foundation;  either version 2.1 of
%    the License, or (at your option) any later version.
%
%    STK-contrib-moo-1 is distributed in the hope that it will be useful,
%    but  WITHOUT  ANY  WARRANTY;  without even  the implied  warranty of
%    MERCHANTABILITY or FITNESS  FOR A  PARTICULAR PURPOSE.  See the  GNU
%    Lesser General Public License for more details.
%
%    You should  have received  a copy  of the  GNU Lesser General Public
%    License along with STK-contrib-moo-1;  if not, see
%                                          <http://www.gnu.org/licenses/>.

function [data] = simulate_nan_data (data, model)

colnames = data.colnames;
data = double(data);
evaluatedData = data(~ any (isnan (data(:, end-1:end)), 2), :);
toSimulateData = data(any (isnan (data(:, end-1:end)), 2), 1:end-2);
n = size (toSimulateData, 1);

z_pred = double ([ ...
    stk_predict(model(1), evaluatedData(:,1:(end-2)), ...
    evaluatedData(:,end-1), toSimulateData)           ...
    stk_predict(model(2), evaluatedData(:,1:(end-2)), ...
    evaluatedData(:,end), toSimulateData)]);

z_sim = [ ...
    z_pred(:,1) + z_pred(:,2) .* rand(n,1), ...
    z_pred(:,3) + z_pred(:,4) .* rand(n,1)  ];

data = stk_dataframe ([evaluatedData ; [toSimulateData z_sim]]);
data.colnames = colnames;

end % function
